#include "FIVEWIN.CH"


PROCEDURE MAIN()

   LOCAL oWnd, oMenu

   MENU oMenu
      MENUITEM "&Probar Excel y DBF"
      MENU
         MENUITEM "&Leer Prueba.XLS" ACTION LEER()
         MENUITEM "&Enviar Prueba.DBF a Excel" ACTION ENVIAR() WHEN FILE( "PRUEBA.DBF" )
         SEPARATOR
         MENUITEM "&Salir" ACTION oWnd:End()
      ENDMENU
   ENDMENU

   DEFINE WINDOW oWnd FROM 0,0 TO 20,70 MENU oMenu ;
          TITLE "Probar Excel y DBF"
   ACTIVATE WINDOW oWnd MAXIMIZED

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE LEER()

   LOCAL oExcel, oHoja, nRows, nCols
   LOCAL aCampos:={}, nRow, nCol

   oExcel := TOleAuto():New( "Excel.Application" )

   oExcel:WorkBooks:Open(cFilePath(GetModuleFileName(GetInstance()))+"Prueba.xls")

   oHoja := oExcel:Get( "ActiveSheet" )

   nRows := oHoja:UsedRange:Rows:Count()
   nCols := oHoja:UsedRange:Columns:Count()

   FOR nCol := 1 TO nCols

      IF ValType( oHoja:Cells( 2, nCol ):Value ) = "C"
         AADD( aCampos, { oHoja:Cells( 1, nCol ):Value, "C", 80, 0 } )

      ELSEIF ValType( oHoja:Cells( 2, nCol ):Value ) = "N"
         AADD( aCampos, { oHoja:Cells( 1, nCol ):Value, "N", 15, 4 } )

      ELSEIF ValType( oHoja:Cells( 2, nCol ):Value ) = "L"
         AADD( aCampos, { oHoja:Cells( 1, nCol ):Value, "L", 1, 0 } )

      ELSEIF ValType( oHoja:Cells( 2, nCol ):Value ) = "D"
         AADD( aCampos, { oHoja:Cells( 1, nCol ):Value, "D", 8, 0 } )
      ENDIF

   NEXT

   DBCREATE( "PRUEBA", aCampos )
   USE "PRUEBA" NEW

   FOR nRow := 2 TO nRows

      APPEND BLANK

      FOR nCol := 1 TO nCols
         FIELDPUT( nCol, oHoja:Cells( nRow, nCol ):Value )
      NEXT

   NEXT

   CLOSE DATABASES

   oExcel:Quit()

   oHoja:End()
   oExcel:End()

   MsgInfo( "Se ha creado el fichero PRUEBA.DBF" )

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE ENVIAR()

   LOCAL oExcel, oHoja
   LOCAL nRow := 1, nCol

   oExcel := TOleAuto():New( "Excel.Application" )

   oExcel:WorkBooks:Add()

   oHoja := oExcel:Get( "ActiveSheet" )

   USE "PRUEBA" NEW

   FOR nCol := 1 TO FCOUNT()
      oHoja:Cells( nRow, nCol ):Value := FieldName( nCol )
   NEXT

   DO WHILE .NOT. EOF()
      nRow++
      FOR nCol := 1 TO FCOUNT()
         oHoja:Cells( nRow, nCol ):Value := FieldGet( nCol )
      NEXT
      SKIP
   ENDDO

   FOR nCol := 1 TO FCOUNT()
      oHoja:Columns( nCol ):AutoFit()
   NEXT

   CLOSE DATABASES

   oExcel:Visible := .T.

   oHoja:End()
   oExcel:End()

RETURN

